<template>
  <close-content
    :suggest-geoloc="false"
    v-show="loadingEvents || events.data.length > 0"
  >
    <template #title>
      {{ $gettext('Online upcoming events') }}
    </template>
    <template #content>
      <skeleton-event-result
        v-for="i in [...Array(6).keys()]"
        class="scroll-ml-6 snap-center shrink-0 w-[18rem] my-4"
        :key="i"
        v-show="loadingEvents"
      />
      <event-result
        class="scroll-ml-6 snap-center shrink-0 first:pl-8 last:pr-8 w-[18rem]"
        v-for="event in events.data"
        :key="event.id"
        :event="event"
        view-mode="column"
        :has-border="true"
        :minimal="true"
      />
      <more-content
        :to="{
          name: 'SEARCH',
          query: {
            contentType: 'EVENTS',
            isOnline: 'true',
          },
        }"
        :picture="{
          url: '/img/online-event.jpg',
          author: {
            name: 'Chris Montgomery',
            url: 'https://unsplash.com/@cwmonty',
          },
          source: {
            name: 'Unsplash',
            url: 'https://unsplash.com/?utm_source=Mobilizon&utm_medium=referral',
          },
        }"
      >
        {{ $gettext('View more online events') }}
      </more-content>
    </template>
  </close-content>
</template>

<script lang="ts" setup>
  import { buildEventSearchQuery } from '../../query/buildQuery'
  import { useGettext } from 'vue3-gettext'
  import { searchEvents } from '../../shared/search'
  import { inject, reactive, ref } from 'vue'
  import { ResultList } from '../../../../server/types/search-query/common-search.model'
  import { EnhancedEvent } from '../../../../server/types/event.model'
  import EventResult from '../../components/result/EventResult.vue'
  import { Locale } from 'date-fns'
  import SkeletonEventResult from '../result/SkeletonEventResult.vue'
  import { boostLanguagesQuery } from '@/query/misc'
  import MoreContent from './MoreContent.vue'
  import CloseContent from './CloseContent.vue'

  const { $gettext } = useGettext()

  const dateFnsLocale = inject<Locale>('dateFnsLocale')

  const events = reactive<ResultList<EnhancedEvent>>({
    total: 0,
    data: [],
  })

  const loadingEvents = ref(true)

  const query = buildEventSearchQuery(
    {
      isOnline: true,
      page: 1,
      resultsPerEventsPage: 5,
      eventStartDateRange: 'future',
      locale: dateFnsLocale,
      sort: 'startTime',
      languageOneOf: boostLanguagesQuery($gettext),
    },
    $gettext
  )

  const fetchedEvents = await searchEvents(query)
  events.total = fetchedEvents.total
  events.data = fetchedEvents.data
  loadingEvents.value = false
</script>
